<?php

namespace App\Controller;

use App\Entity\Site;
use App\Entity\Image;
use App\Entity\Document;
use App\Entity\Bibliography;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\Routing\Attribute\Route;
use Symfony\Bridge\Doctrine\Attribute\MapEntity;

class SiteController extends AbstractController
{
    #[Route('/sites', name: 'app_site')]
    public function index(EntityManagerInterface $em): JsonResponse
    {
        $repo = $em->getRepository(Site::class);

        $sites = $repo->findAll();

        // TODO N+1...
        foreach($sites as $key => $site) {
            $coords = $repo->coordinates($site->getId());
            $site->setLat($coords['lat']);
            $site->setLng($coords['lng']);
            $sites[$key] = $site;
            $repo = $em->getRepository(Image::class);
            $images = new ArrayCollection(
                $repo->findBy(
                    ['site' => $site->getId()],
                    ['sequence' => 'ASC']
                )
            );
            $repo = $em->getRepository(Document::class);
            $documents = $repo->findBySite($site->getId());
            $repo = $em->getRepository(Bibliography::class);
            $bibliography = $repo->findAllBySite($site->getId());

            $site->setImages($images);
            $site->setDocuments($documents);
            $site->setBibliography($bibliography);
            $repo = $em->getRepository(Site::class);
        }

        return $this->json($sites);
    }

    #[Route('/site/{gisId<\w+>}', name: 'app_site_record')]
    public function record(
        #[MapEntity(mapping: ['gisId' => 'gisId'])]
        Site $site,
        EntityManagerInterface $em
    ): JsonResponse
    {
        $repo = $em->getRepository(Site::class);
        $coords = $repo->coordinates($site->getId());
        $repo = $em->getRepository(Image::class);
        $images = new ArrayCollection(
            $repo->findBy(
                ['site' => $site->getId()],
                ['sequence' => 'ASC']
            )
        );
        $repo = $em->getRepository(Document::class);
        $documents = $repo->findBySite($site->getId());
        $repo = $em->getRepository(Bibliography::class);
        $bibliography = $repo->findAllBySite($site->getId());

        $site->setImages($images);
        $site->setDocuments($documents);
        $site->setBibliography($bibliography);
        $site->setLat((float) $coords['lat']);
        $site->setLng((float) $coords['lng']);

        return $this->json($site);
    }
}
